/**
 * @Author: wzy
 * @Date: 2021-11-9
 * @LastEditTime: 
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @filePath:
 */

#pragma once

#include <iostream>
#include <vector>
#include "PD_Input.h"
// #include "mpc_drv_msgs/msg/lane.hpp"
// #include "mpc_drv_msgs/msg/line_type.hpp"
// #include "mpc_drv_msgs/msg/lane_boundary.hpp"
// #include "mpc_drv_msgs/msg/lane_marker.hpp"
#include "PD_DynamicObjRisk.h"
#include "../../source/PD_commonfunc.h"
// #include "../../../../include/CtApBehaviorAnalysis_/interface/rm_road_info.h"

#define FLAG_LGPNSH_IOOUT 0     // switch 1
#if FLAG_LGPNSH_IOOUT != 0
#include <fstream>
#endif

namespace ADC
{
namespace PD_LegalPnsh
{

enum ego_action_type 
{
    NotDefined = 0,
    PD_LF = 1,        // line follow
    PD_LLC = 2,       // left lane change
    PD_RLC = 3,       // right lane change
    PD_LLC_Pre = 4,
    PD_RLC_Pre = 5,
    PD_LaneChangeAbolition = 6,
    PD_ILC = 99
};

class LegalPunishment
{
public:
    LegalPunishment(const PD::PD_Input &pd_input, 
                    const uint8_t pd_LatTrj_EV_ActionType,
                    const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt>& EgoVeh_trace_list);
    ~LegalPunishment() = default;

    bool calculateLegalPunishment();
    bool m_PnshSldnene = false;
    void process();

private:
    bool init(const PD::PD_Input &pd_input, 
              const uint8_t pd_LatTrj_EV_ActionType,
              const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt>& EgoVeh_trace_list);
    bool initFlag = true;

private:
    int _ego_lane_id;                              
    uint8_t _ego_action_type;
    std::vector<uint32_t> _left_lane_market_id_list;
    std::vector<uint32_t> _right_lane_market_id_list;
    std::vector<LineType> _left_line_type_attribute_list;
    std::vector<LineType> _right_line_type_attribute_list;
    std::vector<LaneBoundary> _left_front_lane_boundary_list;
    std::vector<LaneBoundary> _right_front_lane_boundary_list;
    std::vector<LaneMarker> _lane_marker_list;
    std::vector<Lane> _lane_list;
    //主车初始位置与reference line的横向距离
    float _pos_ego_start = 0.0f;
    std::vector<ADC::PD_DynmcObjRsk::EgoVeh_Point> _egoVeh_TrjPnt;

    #if FLAG_LGPNSH_IOOUT != 0
    uint8_t _LineType = 0;
    float _linerange = 0;
    float _carpos = 0;
    #endif
};

}   //namespace PD_Legalpnsh
}   //namespace ADC